(in-package "LTK")

(defgeneric load-and-append-text (txt filename))
(defmethod load-and-append-text((txt text) filename)
  "Load the contents of the file <filename> and append to the textbox"
;  (format-wish "set file [open {~a} \"r\"];~a insert end [read $file];close $file;puts \"asdf\"" filename (widget-path txt) (widget-path txt))
  (format-wish "set file [open {~a} \"r\"];~a insert end [read $file];close $file;puts \"(:DATA asdf)\"" filename (widget-path txt) (widget-path txt))
  (read-data))

(defun tokenize-string (str token)
"Break a string into individual components, seperated by token character."
  (let ((tmp "")
	(ret-list '()))
    (dotimes (n (length str) (append ret-list (list tmp)))
      (if (eq (elt str n) token)
	  (progn
	    (setf ret-list (append ret-list (list tmp)))
	    (setf tmp ""))
	  (setf tmp (concatenate 'string tmp (princ-to-string (elt str n))))))))

(defmethod cursor-index ((text text))
"Return the current position of the text cursor from a text box."
  (let ((*print-readably* nil))
    (format-wish "senddatastring [~a index insert]" (widget-path text))
    (map 'list #'parse-integer (tokenize-string (read-data) #\.))))

(defun ltk-popup (str)
"Displays the a string message to the user, and returns a string typed by the user.
(ltk-popup string-prompt)"
  (let ((ret-value ""))
    (with-ltk ()
      (let* ((frame (make-instance 'frame))
	     (label (make-instance 'label :master frame :text str))
	     (entry (make-instance 'entry :master frame))
	     (button (make-instance 'button :master frame :text "Ok"
				    :command (lambda ()
					       (setf ret-value (text entry))
					       (setf *exit-mainloop* t)))))
	(pack frame)
	(pack label)
	(pack entry)
	(pack button)
	(bind entry "<KeyPress-Return>" 
		  (lambda (evt)
		    (declare (ignore evt))
		    (setf ret-value (text entry))
		    (setf *exit-mainloop* t)))))
    ret-value))
